using System;

// MANDATORY!!! as WSE 1.x does not support SSL client authentication
using Microsoft.Web.Services2;
using Microsoft.Web.Services2.Security;
// DO NOT replace the following line with System.Security...X509Certificates
using Microsoft.Web.Services2.Security.X509;
using Microsoft.Web.Services2.Security.Tokens;

namespace WebServiceSamples
{
	/// <summary>
	/// Sample CertificateInfo web service client.
	/// (c)2004 Halcom informatika, d.o.o.
	/// </summary>
	class CertificateInfoSample
	{
		/// <summary>
		/// Sample CertificateInfo web service client.
		/// </summary>
		public static void client()
		{
			// read a web service client certificate for SSL authentication
			X509Certificate clientCert = X509Certificate.CreateCertFromFile("wsclient.cer");
			X509CertificateStore personalStore = X509CertificateStore.CurrentUserStore(X509CertificateStore.MyStore);
			personalStore.OpenRead();
			X509CertificateCollection certList = personalStore.FindCertificateByHash(clientCert.GetCertHash());
			personalStore.Close();
			if (certList.Count <= 0)
			{
				Console.WriteLine("Web service client certificate not found.");
				return;
			}

			// read a test certificate
			X509Certificate testCert = X509Certificate.CreateCertFromFile("cert.cer");

			// web service input parameters
			string actionPolicy = "";
			string other = "";	// input/ouput
			
			// web service output parameters
			string returnCode;
			string returnText;
			string issuerCN;
			string serialNumber;
			DateTime validFrom;
			DateTime validTo;
			string firstName;
			string lastName;
			string commonName;
			string company;
			string taxNumber;
			string companyTaxNumber;
			string companyID;
						
			// get certificate information
			si.halcom.ws.CertificateInfo cs = new si.halcom.ws.CertificateInfo();
			cs.ClientCertificates.Add(certList[0]);	// SSL client authentication certificate
			returnCode = cs.getCertificateInfo(
				testCert.GetRawCertData(),	// [in]
				actionPolicy,		// [in]
				ref other,			// [in/out]
				out returnText,		// [out]
				out issuerCN,		// [out]
				out serialNumber,	// [out]
				out validFrom,		// [out]
				out validTo,		// [out]
				out firstName,		// [out]
				out lastName,		// [out]
				out commonName,		// [out]
				out company,		// [out]
				out taxNumber,		// [out]
				out companyTaxNumber,	// [out]
				out companyID		// [out]
			);

			// output the results
			Console.WriteLine("Certificate information for " + testCert.GetName());
			Console.WriteLine("returnCode: " + returnCode);
			Console.WriteLine("returnText: " + returnText);
			Console.WriteLine("issuerCN: " + issuerCN);
			Console.WriteLine("serialNumber: " + serialNumber);
			Console.WriteLine("validFrom: " + validFrom);
			Console.WriteLine("validTo: " + validTo);
			Console.WriteLine("firstName: " + firstName);
			Console.WriteLine("lastName: " + lastName);
			Console.WriteLine("commonName: " + commonName);
			Console.WriteLine("company: " + company);
			Console.WriteLine("taxNumber: " + taxNumber);
			Console.WriteLine("companyTaxNumber: " + companyTaxNumber);
			Console.WriteLine("companyID: " + companyID);
			Console.WriteLine("other: " + other);
		}
	}
}
