using System;

// MANDATORY!!! as WSE 1.x does not support SSL client authentication
using Microsoft.Web.Services2;
using Microsoft.Web.Services2.Security;
// DO NOT replace the following line with System.Security...X509Certificates
using Microsoft.Web.Services2.Security.X509;
using Microsoft.Web.Services2.Security.Tokens;

namespace WebServiceSamples
{
	/// <summary>
	/// Sample CertificateStatus web service client.
	/// (c)2004 Halcom informatika, d.o.o.
	/// </summary>
	class CertificateStatusSample
	{
		/// <summary>
		/// Sample CertificateStatus web service client.
		/// </summary>
		public static void client()
		{
			// read a web service client certificate for SSL authentication
			X509Certificate clientCert = X509Certificate.CreateCertFromFile("wsclient.cer");
			X509CertificateStore personalStore = X509CertificateStore.CurrentUserStore(X509CertificateStore.MyStore);
			personalStore.OpenRead();
			X509CertificateCollection certList = personalStore.FindCertificateByHash(clientCert.GetCertHash());
			personalStore.Close();
			if (certList.Count <= 0)
			{
				Console.WriteLine("Web service client certificate not found.");
				return;
			}

			// read a test certificate
			X509Certificate testCert = X509Certificate.CreateCertFromFile("cert.cer");

			// web service input parameters
			string actionPolicy = "";
			string other = "";
			
			// web service output parameters
			string returnCode;
			string returnText;
			string certificateStatus;
			DateTime producedAt;
			DateTime thisUpdate;
			DateTime nextUpdate;
			string revocationReason;
			DateTime revocationDate;
			
			// get certificate status
			si.halcom.ws.CertificateStatus cs = new si.halcom.ws.CertificateStatus();
			cs.ClientCertificates.Add(certList[0]);	// SSL client authentication certificate
			returnCode = cs.getCertificateStatus(
				testCert.GetRawCertData(),	// [in]
				actionPolicy,		// [in]
				ref other,			// [in/out]
				out returnText,			// [out]
				out certificateStatus,	// [out]
				out producedAt,			// [out]
				out thisUpdate,			// [out]
				out nextUpdate,			// [out]
				out revocationReason,	// [out]
				out revocationDate		// [out]
			);

			// output the results
			Console.WriteLine("Certificate status for " + testCert.GetName());
			Console.WriteLine("returnCode: " + returnCode);
			Console.WriteLine("returnText: " + returnText);
			Console.WriteLine("certificateStatus: " + certificateStatus);
			Console.WriteLine("producedAt: " + producedAt);
			Console.WriteLine("thisUpdate: " + thisUpdate);
			Console.WriteLine("nextUpdate: " + nextUpdate);
			Console.WriteLine("revocationReason: " + revocationReason);
			Console.WriteLine("revocationDate: " + revocationDate);
		}
	}
}
