using System;

// MANDATORY!!! as WSE 1.x does not support SSL client authentication
using Microsoft.Web.Services2;
using Microsoft.Web.Services2.Security;
// DO NOT replace the following line with System.Security...X509Certificates
using Microsoft.Web.Services2.Security.X509;
using Microsoft.Web.Services2.Security.Tokens;

namespace WebServiceSamples
{
	/// <summary>
	/// Sample CertificateTaxNumbers web service client.
	/// (c)2004 Halcom informatika, d.o.o.
	/// </summary>
	class CertificateTaxNumbersSample
	{
		/// <summary>
		/// Sample CertificateTaxNumbers web service client.
		/// </summary>
		public static void client()
		{
			// read a web service client certificate for SSL authentication
			X509Certificate clientCert = X509Certificate.CreateCertFromFile("wsclient.cer");
			X509CertificateStore personalStore = X509CertificateStore.CurrentUserStore(X509CertificateStore.MyStore);
			personalStore.OpenRead();
			X509CertificateCollection certList = personalStore.FindCertificateByHash(clientCert.GetCertHash());
			personalStore.Close();
			if (certList.Count <= 0)
			{
				Console.WriteLine("Web service client certificate not found.");
				return;
			}

			// read a test certificate
			X509Certificate testCert = X509Certificate.CreateCertFromFile("cert.cer");

			// web service input parameters
			string taxNumber = "90374312";
			string companyTaxNumber = "43353126";
			string actionPolicy = "";
			string other = "";
			
			// web service output parameters
			string returnCode;
			string returnText;
			string taxNumberStatus;
			string companyTaxNumberStatus;
			
			// verify tax numbers
			si.halcom.ws.CertificateTaxNumbers cs = new si.halcom.ws.CertificateTaxNumbers();
			cs.ClientCertificates.Add(certList[0]);	// SSL client authentication certificate
			returnCode = cs.verifyCertificateTaxNumbers(
				testCert.GetRawCertData(),	// [in]
				taxNumber,			// [in]
				companyTaxNumber,	// [in]
				actionPolicy,		// [in]
				ref other,			// [in/out]
				out returnText,			// [out]
				out taxNumberStatus,	// [out]
				out companyTaxNumberStatus	// [out]
			);

			// output the results
			Console.WriteLine("Certificate tax number status for " + testCert.GetName());
			Console.WriteLine("returnCode: " + returnCode);
			Console.WriteLine("returnText: " + returnText);
			Console.WriteLine("taxNumberStatus: " + taxNumberStatus);
			Console.WriteLine("companyTaxNumberStatus: " + companyTaxNumberStatus);
			Console.WriteLine("other: " + other);
		}
	}
}
